unit base;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, StdCtrls;

type
  TForm1 = class(TForm)
    wb: TWebBrowser;
    procedure FormCreate(Sender: TObject);
    procedure wbBeforeNavigate2(Sender: TObject; const pDisp: IDispatch;
      var URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
      var Cancel: WordBool);
  private
    function WinExecAndWait(FileName,params: string; Visibility: integer): Cardinal;                               {integer}
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  home:string;

implementation

{$R *.dfm}

function TForm1.WinExecAndWait(FileName,params: string; Visibility: integer):
Cardinal;                               {integer}
var
  WorkDir : string;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  WorkDir:=ExtractFileDir(Filename)+'\';

  FillChar(StartupInfo, Sizeof(StartupInfo), #0);
  StartupInfo.cb := Sizeof(StartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := Visibility;
  filename:=filename+' '+params;
  
  if not CreateProcess(
    nil,
    pchar(FileName),          { pointer to command line string }
    nil,                    { pointer to process security attributes }
    nil,                    { pointer to thread security attributes }
    true,                   { handle inheritance flag }
    CREATE_NEW_CONSOLE or   { creation flags }
    NORMAL_PRIORITY_CLASS,
    nil,                    { pointer to new environment block }
    pchar(WorkDir),                { pointer to current directory name, PChar}
    StartupInfo,            { pointer to STARTUPINFO }
    ProcessInfo)            { pointer to PROCESS_INF }
    then Result := INFINITE {-1} else
  begin
    WaitforSingleObject(ProcessInfo.hProcess, INFINITE);

    GetExitCodeProcess(ProcessInfo.hProcess, Result);
    CloseHandle(ProcessInfo.hProcess);  { to prevent memory leaks }
    CloseHandle(ProcessInfo.hThread);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);

begin

     SetWindowLong(Application.Handle, GWL_EXSTYLE, WS_EX_TOOLWINDOW);
     home:='file:\\'+extractFileDir(paramstr(0))+'\index.htm';
     wb.navigate(WideString(home));
     form1.Left:=0;form1.Top:=0;form1.Height:=screen.Height;form1.Width:=screen.Width;
     wb.left:=-2;wb.top:=-2;wb.height:=form1.Height+4;wb.width:=form1.width+40;

end;

procedure TForm1.wbBeforeNavigate2(Sender: TObject; const pDisp: IDispatch;
  var URL, Flags, TargetFrameName, PostData, Headers: OleVariant;
  var Cancel: WordBool);
var u,p:string;
    t:integer;
begin
      u:=url;
      u:=stringReplace(u,'%20',' ',[rfReplaceAll]);
      u:=stringReplace(u,'/','\',[rfReplaceAll]);
      
      t:=pos('?',u);p:='';

      if t<>0 then begin
         p:=copy(u,t+1,length(u)-t);
         u:=copy(u,1,t-1);
      end;

      if Uppercase(copy(u,length(u)-4,4))='QUIT' then application.Terminate;
      if Uppercase(copy(u,1,4))='QUIT' then application.Terminate;


      if Uppercase(copy(u,1,3))='RUN' then begin
         if Uppercase(copy(u,1,6))='RUN://' then u:=copy(u,7,length(u)-6)
         else u:=copy(u,5,length(u)-4);

         Form1.Hide;
         WinExecAndWait(u,p,SW_MAXIMIZE);
         Form1.Show;
         cancel:=true;
      end;
end;

end.
